package addtool.add.model;

import addtool.analysisonadd.ADDVisitor;
import addtool.analysisonadd.Direction;
import addtool.helpers.Values2String;
import org.jscience.mathematics.number.Rational;
import addtool.timeseries.PACTuple;

/**
 * player-driven basic events with their associated player.
 *
 * @author Julia Kraemer juliadk@mail.upb.de
 * @since 15.03.15
 */
public class BasicEventPlayer extends BasicEvent {


    private Player player;

    /**
     * Constructor for a time-driven basic event.
     *
     * @param name               name of the basic event
     * @param successProbability the success probability
     * @param cost               the costs
     * @param id                 id of the basic event (generated by parser)
     * @param player             attacker or defender BE
     */
    public BasicEventPlayer(String name, Rational successProbability, Rational cost, Player player, String id) {
        super(name,successProbability,cost,id);
        if (player == null) {
            throw new IllegalArgumentException("ID and player of a player basic event cannot be null!");
        }
        this.player = player;
    }
    public BasicEventPlayer(String name, Rational successProbability, Rational cost, Player player, String id,Rational uncertainty,Rational delta) {
        super(name,successProbability,cost,id,uncertainty,delta);
        if (player == null) {
            throw new IllegalArgumentException("ID and player of a player basic event cannot be null!");
        }
        this.player = player;
    }
    public BasicEventPlayer(String name, PACTuple successProbability, PACTuple cost, PACTuple delay, String id, Player player){
        super(name,successProbability,cost,delay,id);
        if (player == null) {
            throw new IllegalArgumentException("ID and player of a player basic event cannot be null!");
        }
        this.player = player;
    }

    @Override
    public String toString() {
        return this.getName() + '{' + Values2String.Rational2string(this.getSuccessProbability(),4) +
                ", " + this.getCost().doubleValue() + '}';
    }


    public Player getPlayer() {
        return player;
    }

    public void setPlayer(Player player) {
        this.player = player;
    }

    @Override
    public String getOperatorName() {
        return "BEPlayer";
    }


    public boolean isAttacker() {
        return this.player == Player.Attacker;
    }

    public boolean isDefender() {
        return this.player == Player.Defender;
    }

    public boolean isPlayer(Player p) {
        return player.equals(p);
    }

    @Override
    public void accept(ADDVisitor visitor) {
        accept(visitor, Direction.DOWN);
    }

    @Override
    public void accept(ADDVisitor visitor, Direction direction) {
        switch (direction) {
            case DOWN -> {
                this.getPredecessors().forEach(v -> v.accept(visitor, direction));
                visitor.visit(this);
            }
            case UP -> {
                visitor.visit(this);
                this.getSuccessors().forEach(v -> v.accept(visitor, direction));
            }
        }
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;

        BasicEventPlayer that = (BasicEventPlayer) o;
        return player == that.player;
    }

    @Override
    public int hashCode() {
        int result = super.hashCode();
        result = 31 * result + (player != null ? player.hashCode() : 0);
        return result;
    }

    @Override
    public Vertex copy() {
        BasicEventPlayer an=new BasicEventPlayer(this.getName(),this.getSuccessProbabilityTuple(),this.getCosts(),this.getDelay(),this.getId(),this.getPlayer());
        this.writeValuesTo(an);
        return an;
    }
}

